=== demos/Vamp/visualization/requirements.txt ===
# Requirements for VAMP-OMPL Solution Path Visualizer
# Install with: pip install -r requirements.txt

numpy>=1.20.0
pybullet>=3.2.0
