=== debian/changelog ===
ros-one-ompl (1.8.0-95jammy.20251027.2027) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Mark Moll <mark@moll.ai>  Mon, 27 Oct 2025 20:27:55 +0000

ros-one-ompl (1.8.0-0jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mark Moll <mark@moll.ai>  Mon, 27 Oct 2025 20:27:54 -0000
