=== debian/control ===
Source: ros-one-ompl
Section: misc
Priority: optional
Maintainer: Mark Moll <mark@moll.ai>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-program-options-dev, libboost-serialization-dev, libeigen3-dev, libflann-dev, libyaml-cpp-dev, pkg-config
Homepage: https://ompl.kavrakilab.org
Standards-Version: 3.9.2

Package: ros-one-ompl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-program-options1.74.0, libboost-serialization1.74.0, libeigen3-dev, libflann-dev, libyaml-cpp-dev
Description: OMPL is a free sampling-based motion planning library.
