=== debian/changelog ===
ros-one-ompl (1.8.0-95noble.20251027.2029) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Mark Moll <mark@moll.ai>  Mon, 27 Oct 2025 20:29:16 +0000

ros-one-ompl (1.8.0-0noble) noble; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mark Moll <mark@moll.ai>  Mon, 27 Oct 2025 20:29:16 -0000
