=== debian/control ===
--- 
+++ 
@@ -8,5 +8,5 @@
 
 Package: ros-one-ompl
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-program-options1.74.0, libboost-serialization1.74.0, libeigen3-dev, libflann-dev, libyaml-cpp-dev
+Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-program-options1.83.0, libboost-serialization1.83.0, libeigen3-dev, libflann-dev, libyaml-cpp-dev
 Description: OMPL is a free sampling-based motion planning library.
